/* select statement */

set @comp = 1, @ap = 'IST', @t1 = '2010-06-20 00:00', @t2 = '2010-06-21 00:00';

select AF.msFlightNo as A, DF.msFlightNo as D, count(*)
from ( select L1.mulLandedId
         from PFIFlight A1 use index (ndx_arr_range)
         join PFILanded L1 use index (ndx_arr) on L1.mulArrFlightId = A1.mulFlightId and L1.muhStateId = 1
        where A1.mdtLatestArr >= @t1
          and A1.mdtLatestArr < @t2
          and A1.msArrivalAirport = @ap
        UNION
        select L2.mulLandedId
         from PFIFlight D2 use index (ndx_dep_range)
         join PFILanded L2 use index (ndx_dep) on L2.mulDepFlightId = D2.mulFlightId and L2.muhStateId = 1
        where D2.mdtLatestDep >= @t1
          and D2.mdtLatestDep < @t2
          and D2.msAirportOfDeparture = @ap
) as X
join PFILanded L use index (PRIMARY) on L.mulLandedId = X.mulLandedId and L.muhStateId = 1
join PFILandedCompany LC on LC.mulLandedId = L.mulLandedId and LC.mulCompanyId = 1
left join PFIFlight A on A.mulFlightId = L.mulArrFlightId
left join PFIFlight D on D.mulFlightId = L.mulDepFlightId
left join PFIFlight AX use index (ndx_arr_merge)
           on AX.msACRegCode = D.msACRegCode
          and AX.msArrivalAirport = D.msAirportOfDeparture
          and AX.mulAirlineId = D.mulAirlineId
          and AX.mdtLatestArr = (select max(F.mdtLatestArr)
                                   from PFIFlight F use index (ndx_arr_merge)
                                   join PFILanded L use index (ndx_arr) on L.mulArrFlightId = F.mulFlightId and L.mulDepFlightId is null and L.muhStateId = 1
                                   join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                  where F.msACRegCode = D.msACRegCode
                                    and F.msArrivalAirport = D.msAirportOfDeparture
                                    and F.mulAirlineId = D.mulAirlineId
                                    and F.mdtLatestArr >= date_sub(D.mdtLatestDep, interval 24 hour )
                                    and F.mdtLatestArr < D.mdtLatestDep
                                )
          and AX.mulFlightId = ( select max(F.mulFlightId)
                                   from PFIFlight F use index (ndx_arr_merge)
                                   join PFILanded L use index (ndx_arr) on L.mulArrFlightId = F.mulFlightId and L.mulDepFlightId is null and L.muhStateId = 1
                                   join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                  where F.msACRegCode = AX.msACRegCode
                                    and F.msArrivalAirport = AX.msArrivalAirport
                                    and F.mulAirlineId = AX.mulAirlineId
                                    and F.mdtLatestArr = AX.mdtLatestArr )
left join PFIFlight DX use index (ndx_dep_merge)
           on DX.msACRegCode = A.msACRegCode
          and DX.msAirportOfDeparture = A.msArrivalAirport
          and DX.mulAirlineId = A.mulAirlineId
          and DX.mdtLatestDep = (select min(F.mdtLatestDep)
                                   from PFIFlight F use index (ndx_dep_merge)
                                   join PFILanded L use index (ndx_dep) on L.mulDepFlightId = F.mulFlightId and L.mulArrFlightId is null and L.muhStateId = 1
                                   join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                  where F.msACRegCode = A.msACRegCode
                                    and F.msAirportOfDeparture = A.msArrivalAirport
                                    and F.mulAirlineId = A.mulAirlineId
                                    and F.mdtLatestDep > A.mdtLatestArr
                                    and F.mdtLatestDep <= date_add( A.mdtLatestArr, interval 24 hour )
                                )
          and DX.mulFlightId = ( select min(F.mulFlightId)
                                   from PFIFlight F use index (ndx_dep_merge)
                                   join PFILanded L use index (ndx_dep) on L.mulDepFlightId = F.mulFlightId and L.mulArrFlightId is null and L.muhStateId = 1
                                   join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                  where F.msACRegCode = DX.msACRegCode
                                    and F.msAirportOfDeparture = DX.msAirportOfDeparture
                                    and F.mulAirlineId = DX.mulAirlineId
                                    and F.mdtLatestDep = DX.mdtLatestDep )
left join PFIFlight DXX use index (ndx_dep_merge)
           on DXX.msACRegCode = AX.msACRegCode
          and DXX.msAirportOfDeparture = AX.msArrivalAirport
          and DXX.mulAirlineId = AX.mulAirlineId
          and DXX.mdtLatestDep = (select min(F.mdtLatestDep)
                                    from PFIFlight F use index (ndx_dep_merge)
                                    join PFILanded L use index (ndx_dep) on L.mulDepFlightId = F.mulFlightId and L.mulArrFlightId is null and L.muhStateId = 1
                                    join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                   where F.msACRegCode = AX.msACRegCode
                                     and F.msAirportOfDeparture = AX.msArrivalAirport
                                     and F.mulAirlineId = AX.mulAirlineId
                                     and F.mdtLatestDep > AX.mdtLatestArr
                                     and F.mdtLatestDep <= date_add(AX.mdtLatestArr, interval 24 hour)
                                  )
          and DXX.mulFlightId = (select min(F.mulFlightId)
                                   from PFIFlight F use index (ndx_dep_merge)
                                   join PFILanded L use index (ndx_dep) on L.mulDepFlightId = F.mulFlightId and L.mulArrFlightId is null and L.muhStateId = 1
                                   join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                  where F.msACRegCode = DXX.msACRegCode
                                    and F.msAirportOfDeparture = DXX.msAirportOfDeparture
                                    and F.mulAirlineId = DXX.mulAirlineId
                                    and F.mdtLatestDep = DXX.mdtLatestDep )
left join PFIFlight AXX use index (ndx_arr_merge)
           on AXX.msACRegCode = DX.msACRegCode
          and AXX.msArrivalAirport = DX.msAirportOfDeparture
          and AXX.mulAirlineId = DX.mulAirlineId
          and AXX.mdtLatestArr = (select max(F.mdtLatestArr)
                                    from PFIFlight F use index (ndx_arr_merge)
                                    join PFILanded L use index (ndx_arr) on L.mulArrFlightId = F.mulFlightId and L.mulDepFlightId is null and L.muhStateId = 1
                                    join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                   where F.msACRegCode = DX.msACRegCode
                                     and F.msArrivalAirport = DX.msAirportOfDeparture
                                     and F.mulAirlineId = DX.mulAirlineId
                                     and F.mdtLatestArr >= date_sub(DX.mdtLatestDep, interval 24 hour )
                                     and F.mdtLatestArr < DX.mdtLatestDep
                                  )
          and AXX.mulFlightId = (select max(F.mulFlightId)
                                   from PFIFlight F use index (ndx_arr_merge)
                                   join PFILanded L use index (ndx_arr) on L.mulArrFlightId = F.mulFlightId and L.mulDepFlightId is null and L.muhStateId = 1
                                   join PFILandedCompany C on C.mulLandedId = L.mulLandedId and C.mulCompanyId = LC.mulCompanyId
                                  where F.msACRegCode = AXX.msACRegCode
                                    and F.msArrivalAirport = AXX.msArrivalAirport
                                    and F.mulAirlineId = AXX.mulAirlineId
                                    and F.mdtLatestArr = AXX.mdtLatestArr )
left join PFIFlight AF on AF.mulFlightId = coalesce(A.mulFlightId, case when DXX.mulFlightId = D.mulFlightId then AX.mulFlightId else null end)
left join PFIFlight DF on DF.mulFlightId = coalesce(D.mulFlightId, case when AXX.mulFlightId = A.mulFlightId then DX.mulFlightId else null end)
left join PFILanded LA use index (ndx_arr) on LA.mulArrFlightId = AF.mulFlightId and LA.mulDepFlightId is null and LA.muhStateId = 1
left join PFILanded LD use index (ndx_dep) on LD.mulDepFlightId = DF.mulFlightId and LD.mulArrFlightId is null and LD.muhStateId = 1
group by AF.mulFlightId, DF.mulFlightId
having count(*) > 0
order by max(coalesce(AF.mdtSTA, DF.mdtSTD));

/* expected result set (and achieved thru 4.1.11)

		A       D       count(*)
		------  ------  --------
		1       (NULL)         1
		2       3              2
		(NULL)  4              1
		5       6              1

*/

/* 4.1.12 result set (erroneous)

		A       D       count(*)
		------  ------  --------
		1       (NULL)         1
		2       3              1

*/
